#!/opt/contrib/bin/perl
#==============================================================================
#
# Name:         selectshow.cgi
#
# Written:      Peter Sundstrom (Peter.Sundstrom@daedalus.com.au)
#
# Created:      May 1997
#
# Source:       http://www.daedalus.com.au/peter/tools/slideviewer/
#
# Description:  Simple frontend to start the selected slideshow with
#		the appropriate preferences.
#
# Calls:	slideviewer.cgi
#
# Copyright:    (c)1997 Peter Sundstrom.
#
#               You are free to use and distribute this code as long as the
#               original authors name appears in the header and credits.
#
#               This code can not be used for commercial gain.
#
# Version:	1.0.1
#
#==============================================================================

# URL to slideviewer.cgi
$Slideviewer='/peter/cgi-bin/slideviewer.cgi';

# Path to footer HTML file
$HtmlFooter='/home/peters/www/templates/footer';

#------------------------------------------------------------------------
# END OF CONFIGURABLE OPTIONS
#------------------------------------------------------------------------

$Query = $ENV{QUERY_STRING};
%Data = ();

foreach(split('&', $ENV{QUERY_STRING})) {
  ($name, $value) = split('=', $_);
  $value =~ s!\+! !g; $value =~ s!%(..)!pack('c',hex($1))!eg;
  $Data{$name} = $value;                
}


#
# Set cycle mode
#
if ($Data{cycle}) {
	$Cycle='on';
}
else {
	$Cycle='off';
}

$Show=$Data{show};
$Direction=$Data{direction};
$Slide=$Data{start};

#
# Set display size
#
if ($Data{size} eq 'low') {
	$Scale=-3;
}
elsif ($Data{size} eq 'medium') {
	$Scale=-2;
}
else {
	$Scale=0;
}

&Error("Slide number is not numeric") if ($Slide !~ /\d+/);

print "Content-type: text/html\n";

if ($Data{auto} eq 'on') {
	$Refresh=$Data{refresh};
	&Error("Refresh rate is not numeric") if ($Refresh !~ /\d+/);
	print "Location: $Slideviewer?list=$Show&direction=$Direction&scale=$Sscale&refresh=$Refresh&cycle=$Cycle&slide=$Slide\n\n";
}
else {
	print "Location: $Slideviewer?list=$Show&direction=$Direction&scale=$Scale&cycle=$Cycle&slide=$Slide\n\n";
}

#-----------------------------------------------------------------------------
sub ReadFooter {
        open(FOOTER,"$HtmlFooter") || &Error("Can not open footer: $HtmlFooter")
;

        while (<FOOTER>) {
                print;
        }

        close(FOOTER);
}

#-----------------------------------------------------------------------------
sub Error {
  local($Text)=@_;

  print "Content-type: text/html\n\n";
  print <<HTML
<html>
<head>
<title>Slide Show Error</title>
<body bgcolor="#ffffff">
<center>
<h1>Slide Show Error</h1>
</center>
<p>
$Text<p>

HTML
;

  &ReadFooter;
  exit;
}
